=== debian/changelog ===
texworks (0.5~svn1363-6build2) xenial; urgency=medium

  * No-change rebuild against libhunspell-1.3-0 (-0v5 was a temporary
    intra-wily Ubuntu specific name)

 -- Martin Pitt <martin.pitt@ubuntu.com>  Tue, 05 Apr 2016 21:54:50 +0200

texworks (0.5~svn1363-6build1) xenial; urgency=medium

  * No-change rebuild for hunspell library renaming.

 -- Matthias Klose <doko@ubuntu.com>  Tue, 05 Apr 2016 13:25:26 +0000

texworks (0.5~svn1363-6) unstable; urgency=medium

  * QA upload.
  * Set Maintainer to Debian QA Group.  (See: #773940)
  * Use source format 3.0 (quilt).
  * Link against QtXml to fix FTBFS with Qt 4.8.7.  (Closes: #789842)
  * Switch to debhelper compat level 9.
  * Minimize d/rules using debhelper override targets.
  * Bump Standards-Version to 3.9.6, no changes needed.
  * Import packaging history into GIT, add Vcs-* URLs.

 -- Andreas Beckmann <anbe@debian.org>  Sat, 08 Aug 2015 17:40:06 +0200

texworks (0.5~svn1363-5) unstable; urgency=medium

  * Modify to use the shared library for synctex.  Thanks to Sebastian Ramacher
    <sramacher AT debian.org>  (Closes: #753818)

 -- Atsuhito KOHDA <kohda@debian.org>  Tue, 08 Jul 2014 15:07:38 +0900

texworks (0.5~svn1363-4) unstable; urgency=medium

  * Enabled parallel building.  Thanks to Pino Toscano <pino AT debian.org>.
    (Closes: #749971)

 -- Atsuhito KOHDA <kohda@debian.org>  Fri, 06 Jun 2014 09:32:35 +0900

texworks (0.5~svn1363-3) unstable; urgency=medium

  * Now hopefully we did a decent fix.

 -- Atsuhito KOHDA <kohda@debian.org>  Mon, 26 May 2014 13:25:17 +0900

texworks (0.5~svn1363-2) unstable; urgency=medium

  * In previous packaging, I made mistake but yet I don't get a decent fix,
    the followings are only workaroud.
  * Fixed build process to set TW_PLUGINPATH correctly with an option
    -DTeXworks_PLUGIN_DIR='/usr/lib/texworks'.
  * Removed unnecessary patches and set the option -DWITH_PYTHON=ON and
    -DTeXworks_HELP_DIR='/usr/share/texworks-help'.

 -- Atsuhito KOHDA <kohda@debian.org>  Fri, 23 May 2014 09:46:37 +0900

texworks (0.5~svn1363-1) unstable; urgency=medium

  * New Upstream Release (rev 1363).
  * Adopt new build system with CMake.
   - Rewrite debian/rules for it.
   - Enabling PythonPlugin with modification of CMakeLists.txt .
   - To build texworks-help-en, modify CMakeLists.txt and src/TWUtils.cpp
     but should be refined.  See debian/patch-cm.
   - Set hardened build flags.
  * Cleaning lintian warnings.
   - Stop installing unnecessary COPYING.
   - Bump Standards-Version to 3.9.5 .

 -- Atsuhito KOHDA <kohda@debian.org>  Wed, 14 May 2014 16:24:12 +0900

texworks (0.5~svn1351-1) unstable; urgency=medium

  * New Upstream Release (rev 1351).

 -- Atsuhito KOHDA <kohda@debian.org>  Mon, 27 Jan 2014 14:06:54 +0900

texworks (0.5~svn1302-1) unstable; urgency=low

  * New Upstream Release (rev 1302).

 -- Atsuhito Kohda <kohda@debian.org>  Fri, 30 Aug 2013 15:02:31 +0900

texworks (0.5~svn1288-1) unstable; urgency=low

  * New Upstream Release (rev 1288).
  * Fixed rules clean target.  obj -> objs
  * Fixed control file.  Added zlib1g-dev to Build-Depends field.
    (Closes: #710102)

 -- Atsuhito KOHDA <kohda@debian.org>  Tue, 04 Jun 2013 14:11:27 +0900

texworks (0.5~svn1035-1) unstable; urgency=low

  * New Upstream Release (rev 1035).

 -- Atsuhito KOHDA <kohda@debian.org>  Mon, 25 Feb 2013 15:40:07 +0900

texworks (0.5~svn1031-1) unstable; urgency=low

  * New Upstrean Release (rev 1031).

 -- Atsuhito KOHDA <kohda@debian.org>  Wed, 23 Jan 2013 14:16:22 +0900

texworks (0.5~svn1026-1) unstable; urgency=low

  * New Upstrean Release (rev 1026).

 -- Atsuhito KOHDA <kohda@debian.org>  Thu, 26 Sep 2012 16:48:05 +0900

texworks (0.5~svn1007-1) unstable; urgency=low

  * New Upstream Release (rev 1007).
  * Updated copyright file: added Charlie Sharpsteen as Upstream Authors.

 -- Atsuhito KOHDA <kohda@debian.org>  Wed, 02 May 2012 16:27:37 +0900

texworks (0.5~svn956-1) unstable; urgency=low

  * New Upstream Release (rev 956).
  * Fixed hunspell dictionaries problem with a setting -DTW_DICPATH in rules.
    (Closes: #657702)

 -- Atsuhito KOHDA <kohda@debian.org>  Tue, 31 Jan 2012 08:55:10 +0900

texworks (0.5~svn952-1) unstable; urgency=low

  * New Upstream Release (rev 952).

 -- Atsuhito KOHDA <kohda@debian.org>  Mon, 12 Dec 2011 15:44:20 +0900

texworks (0.5~svn939-2) unstable; urgency=low

  * I failed to apply a patch suggested by Jakub Wilk in the previous
    upload.  This time I believe the patch is applied.  (Closes: #632393)
  * Removed unnecessary patch for luatex.  It was included in the upstream.

 -- Atsuhito KOHDA <kohda@debian.org>  Thu, 29 Sep 2011 07:48:29 +0900

texworks (0.5~svn939-1) unstable; urgency=low

  * New upstream release (rev 939).
  * Applied a patch suggested by Jakub Wilk <jwilk AT debian.org>
    (Closes: #632393)

 -- Atsuhito KOHDA <kohda@debian.org>  Mon, 26 Sep 2011 15:39:22 +0900

texworks (0.5~svn930-1) unstable; urgency=low

  * New upstream release (rev 930).

 -- Atsuhito KOHDA <kohda@debian.org>  Thu, 18 Aug 2011 11:22:40 +0900

texworks (0.5~svn862-1) unstable; urgency=low

  * New upstream release (rev 862).
  * Installed manual borrowed from the latest stable version 0.4.3

 -- Atsuhito KOHDA <kohda@debian.org>  Thu, 14 Jul 2011 08:24:37 +0900

texworks (0.5~svn843-1) unstable; urgency=low

  * New upstream release (rev. 846).
    I tested to build the package on AMD64 and found no problem.
    (Closes: #628276)

 -- Atsuhito KOHDA <kohda@debian.org>  Mon, 13 Jun 2011 17:50:43 +0900

texworks (0.5~svn808-1) unstable; urgency=low

  * New Upstream Release (rev. 808).  (Closes: #625543)
  * Fixed/Updated copyright file; added Stefan Löffler as Upstream Authors.
  * Updated README.Debian a bit.
  * Changed to use texworks.desktop, texworks.1 and .png files
    of source trees instead of obsolete ones under debian.
    To do so, refined rules file a bit.
  * Updated control file and removed unnecessary texworks.menu and COPYING.


