=== debian/rules ===
#!/usr/bin/make -f

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

# For hardening in case CMake
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk
CFLAGS+=$(CPPFLAGS)
CXXFLAGS+=$(CPPFLAGS)

ifneq (,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
NJOBS := -j $(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
endif


%:
	dh $@

override_dh_auto_configure:
	mkdir build && cd build && cmake .. -DTW_BUILD_ID='Debian' -DCMAKE_INSTALL_PREFIX='/usr' -DWITH_PYTHON=ON -DTeXworks_HELP_DIR='/usr/share/texworks-help' && cd ..

override_dh_auto_build:
	cd build && $(MAKE) $(NJOBS) VERBOSE=1

# Build architecture-independent packages
#...
	# DON'T PACKAGE THE MANUAL IN EXPERIMENTAL BUILDS
	# Install the manual
#	mkdir --parents $(CURDIR)/debian/tmp/usr/share/doc/texworks-help/
#	cp -r manual $(CURDIR)/debian/tmp/usr/share/doc/texworks-help/TeXworks-manual

override_dh_auto_install:
	cd build && $(MAKE) install DESTDIR=$(CURDIR)/debian/tmp
	mv $(CURDIR)/debian/tmp/usr/usr/share/texworks-help $(CURDIR)/debian/tmp/usr/share/texworks-help
	rm -rf $(CURDIR)/debian/tmp/usr/usr
	rm $(CURDIR)/debian/tmp/usr/share/doc/texworks/COPYING

override_dh_installchangelogs:
	dh_installchangelogs NEWS
