## texworks 0.6.0

=== debian/changelog ===
texworks (0.6.0-1) unstable; urgency=medium

  * take texworks over into Debian TeX Maint, adjust maint/uploaders
  * Imported Upstream version 0.6.0
  * help files are independently packaged in src:texworks-help

 -- Norbert Preining <preining@debian.org>  Mon, 04 Apr 2016 13:01:25 +0900
